diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
index 9bc0a89d1..bb9cadba5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
@@ -105,7 +105,7 @@ public class ScreenConnecting extends Screen
     {
         renderBackground();
         I18n stringtranslate = I18n.getInstance();
-        if(clientHandler == null)
+        if(clientHandler == null || clientHandler.message == null)
         {
             drawStringCenteredShadow(fontRenderer, stringtranslate.translateKey("gui.connecting.label.connecting"), width / 2, height / 2 - 50, 0xffffff);
             drawStringCenteredShadow(fontRenderer, "", width / 2, height / 2 - 10, 0xffffff);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index fc583f7aa..9c57be8e3 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -85,8 +85,8 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
     public ScreenModelViewer(){
         DisplayChunk.displayBlockId = 0;
         DisplayChunk.displayBlockMeta = 0;
-        mc.currentWorld.loadedEntityList.clear();
-        mc.currentWorld.loadedTileEntityList.clear();
+        mc.currentWorld.entities.clear();
+        mc.currentWorld.tileEntityList.clear();
         mc.thePlayer.absMoveTo(0.5, 64.5, 0.5, 180, 0);
         mc.thePlayer.noPhysics = true;
         mc.textureManager.refreshTexturesAndDisplayErrors();
@@ -331,8 +331,8 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
         }
         if (this.currentCategory == blockCategory && !blockCategoryBulkRenders.isEmpty()) {
             lastInfo = blockCategoryBulkRenders.remove(0);
-            mc.currentWorld.loadedEntityList.clear();
-            mc.currentWorld.loadedTileEntityList.clear();
+            mc.currentWorld.entities.clear();
+            mc.currentWorld.tileEntityList.clear();
             blockCategory.setupRender(lastInfo);
             iRotation = iRotationGoal = lastInfo.renderRotation();
             iZoom = iZoomGoal = lastInfo.renderZoom();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
index 0be3ae05f..f2dabc63c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.gui.modelviewer.categories;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.gui.modelviewer.categories.entries.block.BlockEntryBasic;
@@ -190,7 +189,7 @@ public class ViewerCategoryBlock extends ModelViewerCategory<ViewerCategoryBlock
             entry.onTick(mc.currentWorld, DisplayChunk.displayBlockMeta);
         }
         // Delete any items blocks create when added/removed
-        mc.currentWorld.loadedEntityList.removeIf(entity -> entity instanceof EntityItem);
+        mc.currentWorld.entities.removeIf(entity -> entity instanceof EntityItem);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java
index 865e141e0..ad43af76d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java
@@ -210,7 +210,7 @@ public class ViewerCategoryEntity extends ModelViewerCategory<ModelViewerCategor
     public void removeDisplayEntity(){
         if (displayEntity != null){
             displayEntity.remove();
-            mc.currentWorld.loadedEntityList.remove(displayEntity);
+            mc.currentWorld.entities.remove(displayEntity);
         }
         mc.particleEngine.setWorld(mc.currentWorld);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
index 1e62ca44f..9c84b7a54 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
@@ -28,24 +28,24 @@ public class BlockModelFence<T  extends BlockLogicFence> extends BlockModelStand
         final float f1 = 0.625F;
         AABB bounds = AABB.fromPool(f, 0.0F, f, f1, 1.0F, f1);
         renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-        boolean flag1 = false;
-        boolean flag2 = false;
+        boolean connectedWestEast = false;
+        boolean connectedNorthSouth = false;
         BlockLogicFence fence = block.getLogic();
-        if(fence.canConnectTo(worldSource, x - 1, y, z) || fence.canConnectTo(worldSource, x + 1, y, z))
+        if(fence.canConnectTo(worldSource, x, y, z, Side.WEST) || fence.canConnectTo(worldSource, x, y, z, Side.EAST))
         {
-            flag1 = true;
+            connectedWestEast = true;
         }
-        if(fence.canConnectTo(worldSource, x, y, z - 1) || fence.canConnectTo(worldSource, x, y, z + 1))
+        if(fence.canConnectTo(worldSource, x, y, z, Side.NORTH) || fence.canConnectTo(worldSource, x, y, z, Side.SOUTH))
         {
-            flag2 = true;
+            connectedNorthSouth = true;
         }
-        boolean flag3 = fence.canConnectTo(worldSource, x - 1, y, z);
-        boolean flag4 = fence.canConnectTo(worldSource, x + 1, y, z);
-        boolean flag5 = fence.canConnectTo(worldSource, x, y, z - 1);
-        boolean flag6 = fence.canConnectTo(worldSource, x, y, z + 1);
-        if(!flag1 && !flag2)
+        boolean flag3 = fence.canConnectTo(worldSource, x, y, z, Side.WEST);
+        boolean flag4 = fence.canConnectTo(worldSource, x, y, z, Side.EAST);
+        boolean flag5 = fence.canConnectTo(worldSource, x, y, z, Side.NORTH);
+        boolean flag6 = fence.canConnectTo(worldSource, x, y, z, Side.SOUTH);
+        if(!connectedWestEast && !connectedNorthSouth)
         {
-            flag1 = true;
+            connectedWestEast = true;
         }
         final float f8 = 0.4375F;
         final float f9 = 0.5625F;
@@ -55,24 +55,24 @@ public class BlockModelFence<T  extends BlockLogicFence> extends BlockModelStand
         final float f5 = flag4 ? 1.0F : f9;
         final float f6 = flag5 ? 0.0F : f8;
         final float f7 = flag6 ? 1.0F : f9;
-        if(flag1)
+        if(connectedWestEast)
         {
             bounds.set(f4, f2, f8, f5, f3, f9);
             renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
-        if(flag2)
+        if(connectedNorthSouth)
         {
             bounds.set(f8, f2, f6, f9, f3, f7);
             renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
         final float f10 = 0.375F;
         final float f11 = 0.5625F;
-        if(flag1)
+        if(connectedWestEast)
         {
             bounds.set(f4, f10, f8, f5, f11, f9);
             renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
-        if(flag2)
+        if(connectedNorthSouth)
         {
             bounds.set(f8, f10, f6, f9, f11, f7);
             renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
index 282fc5263..1633f070d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFenceThin;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
@@ -51,10 +52,10 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
 			cEastWest = 0.6f;
 		}
         BlockLogicFenceThin thin = block.getLogic();
-        boolean connectNorth = thin.canConnectTo(worldSource, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY(), z + Direction.NORTH.getOffsetZ());
-        boolean connectSouth = thin.canConnectTo(worldSource, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY(), z + Direction.SOUTH.getOffsetZ());
-        boolean connectEast = thin.canConnectTo(worldSource, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY(), z + Direction.EAST.getOffsetZ());
-        boolean connectWest = thin.canConnectTo(worldSource, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY(), z + Direction.WEST.getOffsetZ());
+        boolean connectNorth = thin.canConnectTo(worldSource, x, y, z, Side.NORTH);
+        boolean connectSouth = thin.canConnectTo(worldSource, x, y, z, Side.SOUTH);
+        boolean connectEast = thin.canConnectTo(worldSource, x, y, z , Side.EAST);
+        boolean connectWest = thin.canConnectTo(worldSource, x, y, z , Side.WEST);
 
         boolean lineNorthSouth = connectNorth && connectSouth;
         boolean lineEastWest = connectEast && connectWest;
@@ -91,16 +92,16 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
         double fenceBottommostMaxV = fenceBottommostTex.getSubIconV(onePix * 16);
 
         Block<?> blockAbove = worldSource.getBlock(x, y + 1, z);
-        boolean connectUpNorth = blockAbove == block && thin.canConnectTo(worldSource, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY() + 1, z + Direction.NORTH.getOffsetZ());
-        boolean connectUpSouth = blockAbove == block && thin.canConnectTo(worldSource, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY() + 1, z + Direction.SOUTH.getOffsetZ());
-        boolean connectUpEast = blockAbove == block && thin.canConnectTo(worldSource, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY() + 1, z + Direction.EAST.getOffsetZ());
-        boolean connectUpWest = blockAbove == block && thin.canConnectTo(worldSource, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY() + 1, z + Direction.WEST.getOffsetZ());
+        boolean connectUpNorth = blockAbove == block && thin.canConnectTo(worldSource, x, y + 1, z, Side.NORTH);
+        boolean connectUpSouth = blockAbove == block && thin.canConnectTo(worldSource, x, y + 1, z, Side.SOUTH);
+        boolean connectUpEast = blockAbove == block && thin.canConnectTo(worldSource, x, y + 1, z, Side.EAST);
+        boolean connectUpWest = blockAbove == block && thin.canConnectTo(worldSource, x, y + 1, z, Side.WEST);
 
         Block<?> blockBelow = worldSource.getBlock(x, y - 1, z);
-        boolean connectDownNorth = blockBelow == block && thin.canConnectTo(worldSource, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY() - 1, z + Direction.NORTH.getOffsetZ());
-        boolean connectDownSouth = blockBelow == block && thin.canConnectTo(worldSource, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY() - 1, z + Direction.SOUTH.getOffsetZ());
-        boolean connectDownEast = blockBelow == block && thin.canConnectTo(worldSource, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY() - 1, z + Direction.EAST.getOffsetZ());
-        boolean connectDownWest = blockBelow == block && thin.canConnectTo(worldSource, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY() - 1, z + Direction.WEST.getOffsetZ());
+        boolean connectDownNorth = blockBelow == block && thin.canConnectTo(worldSource, x, y - 1, z, Side.NORTH);
+        boolean connectDownSouth = blockBelow == block && thin.canConnectTo(worldSource, x, y - 1, z, Side.SOUTH);
+        boolean connectDownEast = blockBelow == block && thin.canConnectTo(worldSource, x, y - 1, z, Side.EAST);
+        boolean connectDownWest = blockBelow == block && thin.canConnectTo(worldSource, x, y - 1, z, Side.WEST);
 
         if (thin.shouldDrawColumn(worldSource, x, y, z))
         {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
index 1f1c2e9b0..a0cca0587 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicRail;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.logic.RailDirection;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
@@ -30,16 +31,13 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
 
     @Override
     public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        int l = worldSource.getBlockMetadata(x, y, z);
-        IconCoordinate i1 = getBlockTextureFromSideAndMetadata(Side.BOTTOM, l);
+        int meta = worldSource.getBlockMetadata(x, y, z);
+        IconCoordinate icon = getBlockTextureFromSideAndMetadata(Side.BOTTOM, meta);
         if(renderBlocks.overrideBlockTexture != null)
         {
-            i1 = renderBlocks.overrideBlockTexture;
-        }
-        if(block.getLogic().getIsPowered())
-        {
-            l &= 7;
+            icon = renderBlocks.overrideBlockTexture;
         }
+        RailDirection railDirection = block.getLogic().getRailDirection(worldSource, x, y, z);
 		float brightness = 1.0f;
 		if(LightmapHelper.isLightmapEnabled()) {
 			if(renderBlocks.overbright) {
@@ -53,68 +51,72 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
 			}
 		}
 		if(renderBlocks.overbright) {
-			i1 = getBlockOverbrightTexture(worldSource, x, y, z, Side.BOTTOM);
-			if(i1 == null) {
-				return false;
-			}
+			icon = getBlockOverbrightTexture(worldSource, x, y, z, Side.BOTTOM);
 		}
+        if(icon == null) { return false; }
+
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
-        double d = i1.getIconUMin();
-        double d1 = i1.getIconUMax();
-        double d2 = i1.getIconVMin();
-        double d3 = i1.getIconVMax();
-        float f1 = 0.0625F;
-        float f2 = x + 1;
-        float f3 = x + 1;
-        float f4 = x;
-        float f5 = x;
-        float f6 = z;
-        float f7 = z + 1;
-        float f8 = z + 1;
-        float f9 = z;
-        float f10 = (float)y + f1;
-        float f11 = (float)y + f1;
-        float f12 = (float)y + f1;
-        float f13 = (float)y + f1;
-        if(l == 1 || l == 2 || l == 3 || l == 7)
-        {
-            f2 = f5 = x + 1;
-            f3 = f4 = x;
-            f6 = f7 = z + 1;
-            f8 = f9 = z;
-        } else
-        if(l == 8)
-        {
-            f2 = f3 = x;
-            f4 = f5 = x + 1;
-            f6 = f9 = z + 1;
-            f7 = f8 = z;
-        } else
-        if(l == 9)
-        {
-            f2 = f5 = x;
-            f3 = f4 = x + 1;
-            f6 = f7 = z;
-            f8 = f9 = z + 1;
+        final double minU = icon.getIconUMin();
+        final double maxU = icon.getIconUMax();
+        final double minV = icon.getIconVMin();
+        final double maxV = icon.getIconVMax();
+        final float yOffset = 1 / 16f; // Offset from the ground
+        float vX1 = x + 1;
+        float vX2 = x + 1;
+        float vX3 = x;
+        float vX4 = x;
+        float vZ1 = z;
+        float vZ2 = z + 1;
+        float vZ3 = z + 1;
+        float vZ4 = z;
+        float vY1 = (float)y + yOffset;
+        float vY2 = (float)y + yOffset;
+        float vY3 = (float)y + yOffset;
+        float vY4 = (float)y + yOffset;
+        switch (railDirection) {
+            case STRAIGHT_EW:
+            case SLOPE_E:
+            case SLOPE_W:
+            case TURN_WS:
+                vX1 = vX4 = x + 1;
+                vX2 = vX3 = x;
+                vZ1 = vZ2 = z + 1;
+                vZ3 = vZ4 = z;
+                break;
+            case TURN_WN:
+                vX1 = vX2 = x;
+                vX3 = vX4 = x + 1;
+                vZ1 = vZ4 = z + 1;
+                vZ2 = vZ3 = z;
+                break;
+            case TURN_EN:
+                vX1 = vX4 = x;
+                vX2 = vX3 = x + 1;
+                vZ1 = vZ2 = z;
+                vZ3 = vZ4 = z + 1;
+                break;
         }
-        if(l == 2 || l == 4)
-        {
-            f10++;
-            f13++;
-        } else
-        if(l == 3 || l == 5)
-        {
-            f11++;
-            f12++;
+        switch (railDirection) {
+            case SLOPE_E:
+            case SLOPE_N:
+                vY1 += 1;
+                vY4 += 1;
+                break;
+            case SLOPE_W:
+            case SLOPE_S:
+                vY2 += 1;
+                vY3 += 1;
+                break;
         }
-        tessellator.addVertexWithUV(f2, f10, f6, d1, d2);
-        tessellator.addVertexWithUV(f3, f11, f7, d1, d3);
-        tessellator.addVertexWithUV(f4, f12, f8, d, d3);
-        tessellator.addVertexWithUV(f5, f13, f9, d, d2);
-        tessellator.addVertexWithUV(f5, f13, f9, d, d2);
-        tessellator.addVertexWithUV(f4, f12, f8, d, d3);
-        tessellator.addVertexWithUV(f3, f11, f7, d1, d3);
-        tessellator.addVertexWithUV(f2, f10, f6, d1, d2);
+        tessellator.addVertexWithUV(vX1, vY1, vZ1, maxU, minV);
+        tessellator.addVertexWithUV(vX2, vY2, vZ2, maxU, maxV);
+        tessellator.addVertexWithUV(vX3, vY3, vZ3, minU, maxV);
+        tessellator.addVertexWithUV(vX4, vY4, vZ4, minU, minV);
+
+        tessellator.addVertexWithUV(vX4, vY4, vZ4, minU, minV);
+        tessellator.addVertexWithUV(vX3, vY3, vZ3, minU, maxV);
+        tessellator.addVertexWithUV(vX2, vY2, vZ2, maxU, maxV);
+        tessellator.addVertexWithUV(vX1, vY1, vZ1, maxU, minV);
         return true;
     }
     @Override
@@ -124,7 +126,7 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
     @Override
     public @Nullable IconCoordinate getBlockOverbrightTexture(WorldSource blockAccess, int x, int y, int z, @NotNull Side side)
     {
-        if (!block.getLogic().isPowered || (blockAccess.getBlockMetadata(x, y, z) & 8) == 0) return null;
+        if (!block.getLogic().isPowered || (blockAccess.getBlockMetadata(x, y, z) & BlockLogicRail.MASK_POWERED) == 0) return null;
 
         return block == Blocks.RAIL_POWERED ? powerActiveOverlay : detectorActiveOverlay;
     }
@@ -132,7 +134,7 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
     @Override
     public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        if(block == Blocks.RAIL_POWERED && (data & 8) != 0)
+        if(block == Blocks.RAIL_POWERED && (data & BlockLogicRail.MASK_POWERED) != 0)
         {
             return powerActive;
         } else if(!block.getLogic().isPowered && data >= 6)
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
index 0b8234b41..83f489b63 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicJarButterfly;
 import net.minecraft.core.block.BlockLogicLanternFirefly;
 import net.minecraft.core.block.BlockLogicRope;
 import net.minecraft.core.block.tag.BlockTags;
@@ -89,9 +90,11 @@ extends BlockModelStandard<T> {
         int blockY = y + side.getOffsetY();
         int blockZ = z + side.getOffsetZ();
         Block<?> _block = worldSource.getBlock(blockX, blockY, blockZ);
-        if (side == Side.BOTTOM){
+        if (side == Side.BOTTOM){ // TODO replace with a proper system for querying what block another block is "attached" to
             if (Block.hasLogicClass(_block, BlockLogicLanternFirefly.class) && (worldSource.getBlockMetadata(blockX, blockY, blockZ) & 0b1) != 0){
                 return true;
+            } else if (Block.hasLogicClass(_block, BlockLogicJarButterfly.class) && (worldSource.getBlockMetadata(blockX, blockY, blockZ) & 0b1) != 0) {
+                return true;
             }
         } else if (side == Side.TOP) {
             if (worldSource.isBlockOpaqueCube(blockX, blockY, blockZ) || BlockTags.CAN_HANG_OFF.appliesTo(_block)) return true;
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
index c0f4a482f..982700b31 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.world;
 
-import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.client.net.handler.PacketHandlerClient;
@@ -47,7 +46,7 @@ public class WorldClientMP extends WorldClient {
         for(int k = 0; k < 10 && !reEntries.isEmpty(); k++)
         {
             Entity entity = reEntries.iterator().next();
-            if(!loadedEntityList.contains(entity))
+            if(!entities.contains(entity))
             {
                 entityJoinedWorld(entity);
             }
@@ -107,12 +106,12 @@ public class WorldClientMP extends WorldClient {
     }
 
     @Override
-	public void scheduleBlockUpdate(int x, int y, int z, int id, int delay)
+	public void scheduleBlockUpdate(int x, int y, int z, int id, long delay)
     {
     }
 
     @Override
-	public boolean tickUpdates(boolean all)
+	public boolean tickPendingTicks(boolean all)
     {
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/Global.java b/game/core/src/main/java/net/minecraft/core/Global.java
index 7223bf108..0c8c58c74 100644
--- a/game/core/src/main/java/net/minecraft/core/Global.java
+++ b/game/core/src/main/java/net/minecraft/core/Global.java
@@ -8,7 +8,7 @@ public class Global
 	public static final long BUILD_TIME = Version.BUILD_TIME;
 	public static final BuildChannel BUILD_CHANNEL = Version.BUILD_CHANNEL;
 	public static final int CURRENT_SAVE_VERSION = 19134;
-	public static final int CURRENT_CHUNK_VERSION = 2;
+	public static final int CURRENT_CHUNK_VERSION = 3;
 	public static boolean isServer = false;
 	public static final boolean DISABLE_OLD_WORLDS = false;
 	public static final int ASSET_PACK_FORMAT = Version.ASSET_PACK_FORMAT;
diff --git a/game/core/src/main/java/net/minecraft/core/NextTickListEntry.java b/game/core/src/main/java/net/minecraft/core/NextTickListEntry.java
index 58a8b6c2b..8ff26b7d8 100644
--- a/game/core/src/main/java/net/minecraft/core/NextTickListEntry.java
+++ b/game/core/src/main/java/net/minecraft/core/NextTickListEntry.java
@@ -1,66 +1,131 @@
 package net.minecraft.core;
 
 
+import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.world.chunk.Chunk;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
 public class NextTickListEntry
-    implements Comparable<NextTickListEntry>
-{
+    implements Comparable<NextTickListEntry> {
+
+    public static @NotNull CompoundTag serialize(final @NotNull NextTickListEntry entry) {
+        final @NotNull CompoundTag tag = new CompoundTag();
+
+        tag.putInt("pos", compressChunkCoord((short) entry.x, (short) entry.y, (short) entry.z));
+        tag.putShort("blockId", (short) entry.blockId);
+        tag.putLong("creationTime", entry.creationTime);
+        if (entry.delay != 0) {
+            tag.putLong("delay", entry.delay);
+        }
+
+        return tag;
+    }
+
+    public static @Nullable NextTickListEntry deserialize(final @NotNull CompoundTag tag) {
+        if (!tag.containsKey("pos")) {
+            return null;
+        }
+        final int pos = tag.getInteger("pos");
+
+        final short @NotNull [] xyz = new short[3];
+        decompressChunkCoord(pos, xyz);
+
+        if (!tag.containsKey("blockId")) {
+            return null;
+        }
+        final short blockId = tag.getShort("blockId");
+
+        if (!tag.containsKey("creationTime")) {
+            return null;
+        }
+        final long creationTime = tag.getLong("creationTime");
+
+        final @NotNull NextTickListEntry entry = new NextTickListEntry(xyz[0], xyz[1], xyz[2], blockId, creationTime);
+
+        if (tag.containsKey("delay")) {
+            entry.setDelay(tag.getLong("delay"));
+        }
+
+        return entry;
+    }
+
+    public static int compressChunkCoord(final short x, final short y, final short z) {
+        return ((y & 0xFFFF) << 16) | ((z & 0xFF) << 8) | ((x & 0xFF) << 0);
+    }
+
+    public static void decompressChunkCoord(final int compressed, final short @NotNull [] xyz) {
+        final int y = (compressed & 0xFFFF0000) >> 16;
+        final int z = (compressed & 0x0000FF00) >> 8;
+        final int x = (compressed & 0x000000FF) >> 0;
+
+        xyz[0] = (short) x;
+        xyz[1] = (short) y;
+        xyz[2] = (short) z;
+    }
+
     private static long counter = 0L;
+
     public int x;
     public int y;
     public int z;
     public int blockId;
+    public long creationTime;
     public long delay;
+    public boolean loaded;
     private final long entryId;
 
-    public NextTickListEntry(int x, int y, int z, int blockId)
-    {
-        entryId = counter++;
+    public NextTickListEntry(final int x, final int y, final int z, final int blockId, final long creationTime) {
+        this.entryId = counter++;
         this.x = x;
         this.y = y;
         this.z = z;
         this.blockId = blockId;
+        this.creationTime = creationTime;
     }
 
     @Override
-	public boolean equals(Object obj)
-    {
-        if(obj instanceof NextTickListEntry)
-        {
-            NextTickListEntry nextticklistentry = (NextTickListEntry)obj;
-            return x == nextticklistentry.x && y == nextticklistentry.y && z == nextticklistentry.z && blockId == nextticklistentry.blockId;
-        }
-        else
-        {
+    public boolean equals(final @Nullable Object obj) {
+        if (obj instanceof NextTickListEntry) {
+            final @NotNull NextTickListEntry entry = (NextTickListEntry) obj;
+            return this.x == entry.x && this.y == entry.y && this.z == entry.z && this.blockId == entry.blockId;
+        } else {
             return false;
         }
     }
 
     @Override
-	public int hashCode()
-    {
-        return (x * 128 * 1024 + z * 128 + y) * 256 + blockId;
+    public int hashCode() {
+        return (this.x * 128 * 1024 + this.z * 128 + this.y) * 256 + this.blockId;
     }
 
-    public NextTickListEntry setDelay(long delay)
-    {
+    public @NotNull NextTickListEntry setDelay(final long delay) {
         this.delay = delay;
         return this;
     }
 
+    public long getEndTime() {
+        return this.creationTime + this.delay;
+    }
+
     @Override
-	public int compareTo(NextTickListEntry other) {
-        if(delay < other.delay)
-        {
+    public int compareTo(final @NotNull NextTickListEntry other) {
+        if (this.getEndTime() < other.getEndTime()) {
             return -1;
         }
-        if(delay > other.delay)
-        {
+        if (this.getEndTime() > other.getEndTime()) {
             return 1;
         }
-        if(entryId < other.entryId)
-        {
+        if (this.entryId < other.entryId) {
             return -1;
         }
-        return entryId <= other.entryId ? 0 : 1;
+        return this.entryId <= other.entryId ? 0 : 1;
+    }
+
+    public @NotNull NextTickListEntry clone() {
+        final @NotNull NextTickListEntry cloned = new NextTickListEntry(this.x, this.y, this.z, this.blockId, this.creationTime);
+        cloned.delay = this.delay;
+
+        return cloned;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index e11b96a93..5275da452 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -619,6 +619,11 @@ public final class Block<T extends BlockLogic>
         return logic.isEquivalent(world, thisX, thisY, thisZ, otherX, otherY, otherZ);
     }
 
+    @Override
+    public @NotNull Side getAttachedSide(@NotNull WorldSource world, int x, int y, int z) {
+        return logic.getAttachedSide(world, x, y, z);
+    }
+
     public static boolean hasLogicClass(@Nullable Block<?> block, Class<?> logicClass) {
         return block != null && logicClass.isAssignableFrom(block.getLogic().getClass());
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
index 671421c04..75965220c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
@@ -109,4 +109,5 @@ interface BlockInterface {
     int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced);
     boolean isClimbable(World world, int x, int y, int z);
     boolean isEquivalent(@NotNull World world, int thisX, int thisY, int thisZ, int otherX, int otherY, int otherZ);
+    @NotNull Side getAttachedSide(@NotNull WorldSource world, int x, int y, int z);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
index 282862f05..b31ca89f4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -500,6 +500,11 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
         return this.block == bBlock && thisMeta == otherMeta;
     }
 
+    @Override
+    public @NotNull Side getAttachedSide(@NotNull WorldSource world, int x, int y, int z) {
+        return Side.NONE;
+    }
+
     @Override
     public Item asItem() {
         return block.asItem();
